
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Offer_scoresDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const offer_scores = await db.offer_scores.create(
            {
                id: data.id || undefined,
        
        score: data.score
        ||
        null
            ,
            
        comment: data.comment
        ||
        null
            ,
            
        scored_at: data.scored_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await offer_scores.setTenant( data.tenant || null, {
            transaction,
        });
        
        await offer_scores.setSupplier_offer( data.supplier_offer || null, {
            transaction,
        });
        
        await offer_scores.setBid_criterion( data.bid_criterion || null, {
            transaction,
        });
        
        await offer_scores.setScored_by( data.scored_by || null, {
            transaction,
        });
        
        await offer_scores.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return offer_scores;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const offer_scoresData = data.map((item, index) => ({
                id: item.id || undefined,
                
                score: item.score
            ||
            null
            ,
            
                comment: item.comment
            ||
            null
            ,
            
                scored_at: item.scored_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const offer_scores = await db.offer_scores.bulkCreate(offer_scoresData, { transaction });

        // For each item created, replace relation files
        

        return offer_scores;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const offer_scores = await db.offer_scores.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.score !== undefined) updatePayload.score = data.score;
        
        
        if (data.comment !== undefined) updatePayload.comment = data.comment;
        
        
        if (data.scored_at !== undefined) updatePayload.scored_at = data.scored_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await offer_scores.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await offer_scores.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.supplier_offer !== undefined) {
            await offer_scores.setSupplier_offer(
              
              data.supplier_offer,
              
              { transaction }
            );
        }
        
        if (data.bid_criterion !== undefined) {
            await offer_scores.setBid_criterion(
              
              data.bid_criterion,
              
              { transaction }
            );
        }
        
        if (data.scored_by !== undefined) {
            await offer_scores.setScored_by(
              
              data.scored_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await offer_scores.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return offer_scores;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const offer_scores = await db.offer_scores.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of offer_scores) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of offer_scores) {
                await record.destroy({transaction});
            }
        });


        return offer_scores;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const offer_scores = await db.offer_scores.findByPk(id, options);

        await offer_scores.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await offer_scores.destroy({
            transaction
        });

        return offer_scores;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const offer_scores = await db.offer_scores.findOne(
            { where },
            { transaction },
        );

        if (!offer_scores) {
            return offer_scores;
        }

        const output = offer_scores.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await offer_scores.getTenant({
            transaction
        });
        
        
        output.supplier_offer = await offer_scores.getSupplier_offer({
            transaction
        });
        
        
        output.bid_criterion = await offer_scores.getBid_criterion({
            transaction
        });
        
        
        output.scored_by = await offer_scores.getScored_by({
            transaction
        });
        
        
        output.organizations = await offer_scores.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.supplier_offers,
        as: 'supplier_offer',
        
        where: filter.supplier_offer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.supplier_offer.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.supplier_offer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.bid_criteria,
        as: 'bid_criterion',
        
        where: filter.bid_criterion ? {
          [Op.or]: [
            { id: { [Op.in]: filter.bid_criterion.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.bid_criterion.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'scored_by',
        
        where: filter.scored_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.scored_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.scored_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.comment) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'offer_scores',
                        'comment',
                        filter.comment,
                    ),
                };
            }
            

            
            

            
            if (filter.scoreRange) {
                const [start, end] = filter.scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.scored_atRange) {
                const [start, end] = filter.scored_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    scored_at: {
                    ...where.scored_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    scored_at: {
                    ...where.scored_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.offer_scores.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'offer_scores',
                        'comment',
                        query,
                    ),
                ],
            };
        }

        const records = await db.offer_scores.findAll({
            attributes: [ 'id', 'comment' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['comment', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.comment,
        }));
    }

    
};

